// asu.sp

#define PLUGIN_VERSION		"1.2.1-rev7"
#define PLUGIN_NAME		"[L4D] Survivor Upgrades"
#define NSKILLS			16
#define NUPGRADES		31

#include <sourcemod>
#include <sdktools>
#include "edlib.sp"

new Handle:AddUpgrade = INVALID_HANDLE;
new Handle:RemoveUpgrade = INVALID_HANDLE;
new Handle:Cvar_Upgrades = INVALID_HANDLE;
new Handle:Cvar_UpgradesLimit = INVALID_HANDLE;
new Handle:Cvar_UpgradesRandom = INVALID_HANDLE;

public Plugin:myinfo =
{
	name = PLUGIN_NAME,
	author = "Evil Boomer Santa Claus, EDSHOT",
	description = "(A)? (S)urvivor (U)pgrades - A modification for the game Left 4 Dead",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/showthread.php?t=94854?t=94854"
};

public OnPluginStart()
{
	if (GetEngineVersion() != Engine_Left4Dead)
	{
		SetFailState("ASU is only supported by Left 4 Dead 1.");
	}

	new Handle:hConfig = LoadGameConfigFile("L4D_Asu");
	if (hConfig == INVALID_HANDLE)
	{
		SetFailState("Could not load L4D_Asu gamedata.");
	}

	StartPrepSDKCall(SDKCall_Player);
	if (PrepSDKCall_SetFromConf(hConfig, SDKConf_Signature, "AddUpgrade"))
	{
		PrepSDKCall_AddParameter(SDKType_PlainOldData, SDKPass_ByValue);
		AddUpgrade = EndPrepSDKCall();
	}

	StartPrepSDKCall(SDKCall_Player);
	if (PrepSDKCall_SetFromConf(hConfig, SDKConf_Signature, "RemoveUpgrade"))
	{
		PrepSDKCall_AddParameter(SDKType_PlainOldData, SDKPass_ByValue);
		RemoveUpgrade = EndPrepSDKCall();
	}

	CreateConVar("sm_asu_limit", "2", "ASU Limit", FCVAR_NOTIFY, true, 0.0, false, 0.0);
	CreateConVar("sm_asu_random", "2", "0: Ordered Upgrades | 1: Random Upgrades | 2: Random Upgrades For Each Player", FCVAR_NOTIFY, true, 0.0, true, 2.0);

	RegConsoleCmd("sm_laseron", LaserMeOn);
	RegConsoleCmd("sm_laseroff", LaserMeOff);
	RegConsoleCmd("sm_jg", asuLaserJGFunction);
	RegConsoleCmd("sm_asu", asuMenu);

	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("tank_killed", Event_TankKilled);
	HookEvent("map_transition", Event_MapTransition);
	HookEvent("mission_lost", Event_MissionLost);
	HookEvent("finale_win", Event_FinaleWin);
	HookUserMessage(GetUserMessageId("SayText"), SayTextHook, true);

	Cvar_Upgrades = FindConVar("survivor_upgrades");
	Cvar_UpgradesLimit = FindConVar("sm_asu_limit");
	Cvar_UpgradesRandom = FindConVar("sm_asu_random");

	LoadTranslations("asu.phrases");

	LogAction(0, -1, "%s %s has been loaded.", PLUGIN_NAME, PLUGIN_VERSION);
}

public OnPluginEnd()
{
	CloseHandle(Cvar_Upgrades);
	CloseHandle(Cvar_UpgradesLimit);
	CloseHandle(Cvar_UpgradesRandom);

	UnhookEvent("player_death", Event_PlayerDeath);
	UnhookEvent("tank_killed", Event_TankKilled);
	UnhookEvent("map_transition", Event_MapTransition);
	UnhookEvent("mission_lost", Event_MissionLost);
	UnhookUserMessage(GetUserMessageId("SayText"), SayTextHook, true);

	CloseHandle(AddUpgrade);
	CloseHandle(RemoveUpgrade);

	PrintToChatAll("ASU plugin has been unloaded. If loaded again, ASU counter will be reset!");
	LogAction(0, -1, "%s %s has been unloaded.", PLUGIN_NAME, PLUGIN_VERSION);
}

public char buf[128];
public bool asuLaserJG = false;
public int asuUsage[32];
public int asuRandomUpgradeNumber;
static int asuRandomUpgrade[13] = {16, 20, 21, 29, 1, 13, 11, 12, 26, 8, 19, 27, 28};

public Action:asuMenu(client, args)
{
	if (!asuCheck(client)) return Plugin_Handled;
	new Handle:menu = CreateMenu(asuMenuHandler);
	Format(buf, sizeof(buf), "%T (%T)", "MENU_TITLE", client, "PLAYER_UPGRADESLEFT", client, (GetConVarInt(Cvar_UpgradesLimit) - asuUsage[client]));
	SetMenuTitle(menu, buf);
	Format(buf, sizeof(buf), "%T %d", "MENU_OPTION", client, 1);
	AddMenuItem(menu, "option0", buf);
	Format(buf, sizeof(buf), "%T %d", "MENU_OPTION", client, 2);
	AddMenuItem(menu, "option1", buf);
	Format(buf, sizeof(buf), "%T %d", "MENU_OPTION", client, 3);
	AddMenuItem(menu, "option2", buf);
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
	return Plugin_Handled;
}

public asuMenuHandler(Handle:menu, MenuAction:action, client, args)
{
	if (action == MenuAction_Select)
	{
	   switch (args)
	   {
		case 0: Menu_su1(client, false);
		case 1: Menu_su2(client, false);
		case 2: Menu_su3(client, false);
	   }
	}
	else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}

// This menu deals with all the commands related to the director
public Action:Menu_su1(client, args)
{
	new Handle:menu = CreateMenu(MenuHandler_su1);
	Format(buf, sizeof(buf), "%T %d", "MENU_OPTION", client, 1);
	SetMenuTitle(menu, buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_HEALTH", client);
	AddMenuItem(menu, "au1", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_LASER", client);
	AddMenuItem(menu, "au2", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_AMMO", client);
	AddMenuItem(menu, "au3", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_DAMAGE", client);
	AddMenuItem(menu, "au4", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_RELOAD", client);
	AddMenuItem(menu, "au5", buf);
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
	return Plugin_Handled;
}

public MenuHandler_su1(Handle:menu, MenuAction:action, cindex, itempos)
{
	if (action == MenuAction_Select)
	{
		switch (itempos)
		{
			// 
			// Avoid giving a player 150 if they have more than 150HP.
			// - EDSHOT
			// 
			case 0: if (GetClientHealth(cindex) <= 150) SpawnItem(cindex, 16);
			case 1: SpawnItem(cindex, 17);
			case 2: SpawnItem(cindex, 20);
			case 3: SpawnItem(cindex, 21);
			case 4: SpawnItem(cindex, 29);
		}
		// 
		// Its pretty annoying when I can't close the asu menu by typing !asu and pressing 5
		// because i'm out of upgrades and there really isn't a point in keeping the window open
		// if you're out of upgrades anyways.
		// 
		// There is a fix to be able to press 6 to close the menu, but most people won't have the
		// fix applied.
		// 
		// - EDSHOT
		// 
		if (asuCheck(cindex)) Menu_su1(cindex, false);
	}
	else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}

// This menu deals with spawning weapons
public Action:Menu_su2(client, args)
{
	new Handle:menu = CreateMenu(MenuHandler_su2);
	Format(buf, sizeof(buf), "%T %d", "MENU_OPTION", client, 2);
	SetMenuTitle(menu, buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_ARMOR", client);
	AddMenuItem(menu, "au6", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_NOBOOMERVOMIT", client);
	AddMenuItem(menu, "au7", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_SSLEDGE", client);
	AddMenuItem(menu, "au8", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_SSREVIVE", client);
	AddMenuItem(menu, "au9", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_SSKNIFE", client);
	AddMenuItem(menu, "au10", buf);
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
	return Plugin_Handled;
}

public MenuHandler_su2(Handle:menu, MenuAction:action, cindex, itempos)
{
	if (action == MenuAction_Select)
	{
		switch (itempos)
		{
			case 0: SpawnItem(cindex, 1);
			case 1: SpawnItem(cindex, 13);
			case 2: SpawnItem(cindex, 11);
			case 3: SpawnItem(cindex, 12);
			case 4: SpawnItem(cindex, 26);
		}
		if (asuCheck(cindex)) Menu_su2(cindex, false);
	}
	else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}

// This menu deals with spawning items
public Action:Menu_su3(client, args)
{
	new Handle:menu = CreateMenu(MenuHandler_su3);
	Format(buf, sizeof(buf), "%T %d", "MENU_OPTION", client, 3);
	SetMenuTitle(menu, buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_NOBOOMERHORDE", client);
	AddMenuItem(menu, "au11", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_RECOIL", client);
	AddMenuItem(menu, "au12", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_FASTREVIVE", client);
	AddMenuItem(menu, "au13", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_MEDIC", client);
	AddMenuItem(menu, "au14", buf);
	Format(buf, sizeof(buf), "%T", "UPGRADE_BULBINGFLASH", client);
	AddMenuItem(menu, "au15", buf);
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, 20);
	return Plugin_Handled;
}

public MenuHandler_su3(Handle:menu, MenuAction:action, cindex, itempos)
{
	if (action == MenuAction_Select)
	{
		switch (itempos)
		{
			case 0: SpawnItem(cindex, 8);
			case 1: SpawnItem(cindex, 19);
			case 2: SpawnItem(cindex, 27);
			case 3: SpawnItem(cindex, 28);
			case 4: SpawnItem(cindex, 30);
		}
		if (asuCheck(cindex)) Menu_su3(cindex, false);
	}
	else if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}

SpawnItem(client, int upgrade)
{
	if (asuCheck(client))
	{
		SDKCall(AddUpgrade, client, upgrade);
		asuIncreaseUsage(client);
	}
}

public Action:LaserMeOn(client, args)
{ 
	SDKCall(AddUpgrade, client, 17);
	return Plugin_Continue;
}

public Action:LaserMeOff(client, args)
{ 
	SDKCall(RemoveUpgrade, client, 17);
	return Plugin_Continue;
}

public Action:asuLaserJGFunction(client, args)
{
	if (!asuLaserJG)
	{
		asuLaserJG = true;
		LaserMeOn(client, args);
	}
	else
	{
		asuLaserJG = false;
		LaserMeOff(client, args);
	}
	return Plugin_Continue;
}

public bool asuCheck(client)
{
	if (GetConVarInt(Cvar_Upgrades) != 1)
	{
		return false;
	}
	if (asuUsage[client] == GetConVarInt(Cvar_UpgradesLimit))
	{
		Format(buf, sizeof(buf), "%T", "PLAYER_NOMOREUPGRADES", client);
		PrintToChat(client, buf);
		return false;
	}

	return true;
}

public void asuIncreaseUsage(client)
{
	asuUsage[client]++;
	Format(buf, sizeof(buf), "%T", "PLAYER_UPGRADESLEFT", client, (GetConVarInt(Cvar_UpgradesLimit) - asuUsage[client]));
	PrintToChat(client, buf);
}

public void asuResetForAll()
{
	for (int p = 1; p <= GetMaxClients(); p++)
	{
		if (IsClientInGame(p)) asuUsage[p] = 0;
	}
}

public void Event_TankKilled(Event event, const char[] name, bool dontBroadcast)
{
	if (GetConVarInt(Cvar_UpgradesRandom) == 1)
	{
		asuRandomUpgradeNumber = GetRandomInt(0, 12);
	}
	else if (GetConVarInt(Cvar_UpgradesRandom) == 2)
	{
	}
	else
	{
		asuRandomUpgradeNumber++;
		if (asuRandomUpgradeNumber == 13) asuRandomUpgradeNumber = 0;
	}

	for (int p = 1; p <= GetMaxClients(); p++)
	{
		if (GetConVarInt(Cvar_UpgradesRandom) == 2)
		{
			asuRandomUpgradeNumber = GetRandomInt(0, 12);
		}

		if (IsClientInGame(p) && GetConVarInt(Cvar_Upgrades) != 0)
		{
			// 
			// Laser and Bulbing Flash are excluded.
			// - EDSHOT
			// 
			switch (asuRandomUpgradeNumber)
			{
				case 0:
				{
					if (GetClientHealth(p) <= 150) SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_HEALTH", p);
					PrintToChat(p, buf);
				}
				case 1:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_AMMO", p);
					PrintToChat(p, buf);
				}
				case 2:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_DAMAGE", p);
					PrintToChat(p, buf);
				}
				case 3:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_RELOAD", p);
					PrintToChat(p, buf);
				}
				case 4:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_ARMOR", p);
					PrintToChat(p, buf);
				}
				case 5:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_NOBOOMERVOMIT", p);
					PrintToChat(p, buf);
				}
				case 6:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_SSLEDGE", p);
					PrintToChat(p, buf);
				}
				case 7:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_SSREVIVE", p);
					PrintToChat(p, buf);
				}
				case 8:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_SSKNIFE", p);
					PrintToChat(p, buf);
				}
				case 9:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_NOBOOMERHORDE", p);
					PrintToChat(p, buf);
				}
				case 10:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_RECOIL", p);
					PrintToChat(p, buf);
				}
				case 11:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_FASTREVIVE", p);
					PrintToChat(p, buf);
				}
				case 12:
				{
					SDKCall(AddUpgrade, p, asuRandomUpgrade[asuRandomUpgradeNumber]);
					Format(buf, sizeof(buf), "%T: %T", "PLAYER_RECIEVEDUPGRADE", p, "UPGRADE_MEDIC", p);
					PrintToChat(p, buf);
				}
			}
		}
	}
}

public void Event_PlayerDeath(Event event, const char[] name, bool dontBroadcast)
{
	for (int p = 1; p <= GetMaxClients(); p++)
	{
		if (IsClientInGame(p) && !IsPlayerAlive(p)) asuUsage[p] = 0;
	}
}

public void Event_MapTransition(Event event, const char[] name, bool dontBroadcast)
{
	asuResetForAll();
}

public void Event_MissionLost(Event event, const char[] name, bool dontBroadcast)
{
	asuResetForAll();
}

public void Event_FinaleWin(Event event, const char[] name, bool dontBroadcast)
{
	asuResetForAll();
}

// 
// From https://forums.alliedmods.net/showthread.php?p=854630
// - EDSHOT
// 
public Action:SayTextHook(UserMsg:msg_id, Handle:bf, const players[], playersNum, bool:reliable, bool:init)
{
	new String:message[1024];
	BfReadByte(bf);
	BfReadByte(bf);
	BfReadString(bf, message, 1024);

	if (StrContains(message, "prevent_it_expire") != -1)
	{
		CreateTimer(0.1, DelayPrintExpire, 1);
		return Plugin_Handled;
	}			
	if (StrContains(message, "ledge_save_expire") != -1)
	{
		CreateTimer(0.1, DelayPrintExpire, 2);
		return Plugin_Handled;
	}
	if (StrContains(message, "revive_self_expire") != -1)
	{
		CreateTimer(0.1, DelayPrintExpire, 3);
		return Plugin_Handled;
	}
	if (StrContains(message, "knife_expire") != -1)
	{
		CreateTimer(0.1, DelayPrintExpire, 4);
		return Plugin_Handled;
	}

	if (StrContains(message, "laser_sight_expire") != -1)
	{
		return Plugin_Handled;
	}

	if (StrContains(message, "_expire") != -1)
	{
		return Plugin_Handled;
	}

	if (StrContains(message, "#L4D_Upgrade_") != -1)
	{
		if (StrContains(message, "description") != -1)
		{
			return Plugin_Handled;
		}
	}

	if (StrContains(message, "NOTIFY_VOMIT_ON") != -1)
	{
		return Plugin_Handled;
	}

	return Plugin_Continue;
}

public Action:DelayPrintExpire(Handle:hTimer, any:text)
{
	switch (text)
	{
		case 1: PrintToChatAllTranslated("UPGRADE_MSG_NOBOOMERVOMIT", "", "");
		case 2: PrintToChatAllTranslated("UPGRADE_MSG_LEDGE", "", "");
		case 3: PrintToChatAllTranslated("UPGRADE_MSG_REVIVE", "", "");
		case 4: PrintToChatAllTranslated("UPGRADE_MSG_KNIFE", "", "");
	}
}
